(() => {
    let eventSource;
    let failedCount = 0;
    function initEventSource()
    {
        eventSource = ({{ subscribe|raw }});
        eventSource.onmessage = event => {
            ({{ callback|raw }})(JSON.parse(event.data), {{ topics|json_encode|raw }});
        };

        eventSource.onerror = function(event) {
            if (event.target.readyState === EventSource.CONNECTING) {
                eventSource.close();
                initEventSource();
            } else if (event.target.readyState === EventSource.CLOSED) {
                failedCount++;
                if (failedCount < 6) {
                    setTimeout(() => initEventSource(), 5000);
                }
            }
        };
    }
    initEventSource();

    window.addEventListener('beforeunload', () => eventSource.close());
})();
